
; Loader fuer CPD2

		TITLE	CPD2LDR

		.Z80


; ***** Programmbeginn *****




START:
		LD	SP,STACK

		DI

	; setzen der RAM-Zellen

	; Laden der RAMZELLE RAM_PIO1BDAR mit Initialisierungswert 
		LD 	A,PIO1BDAR
		LD	(RAM_PIO1BDAR),A

		CALL	INIT


	; Ruecksetzen fuer den naechsen Lauf

		LD	HL,RAM_PIO1BDAR
		RES	BIT_LED_RT,(HL)
	
		LD	H,6

; ********** Zeitschleife 0,4 Sekunde ******************
		; 4 MHz = 0,25 uS

m4:		LD	L,2

		; etwa 0,18 S		
m3:		LD	C,0	; 7T
		;
m2:		LD	B,0	; 7T
		;
m1:		DEC	B	; 4T
		JR	NZ,m1	; 7T / 12T / 11T*254=2794T+12T+7T=2813T
		;
		DEC	C	; 4T
		JR	NZ,m2	; 7T / 12T / 2813T+11T=2824T*254=717296T+12T+7T=717315T
		;
		DEC	L
		JR	NZ,m3

; ********** Zeitschleife 0,4 Sekunde ******************


		; hier sind wir etwa drei mal pro Sekunde

		LD	A,(RAM_PIO1BDAR)
		OUT	(PIO1BD),A
		;	
		BIT	BIT_LED_RT,A
		JR	Z,m5
		;
		RES	BIT_LED_RT,A
		;
		JR	m6
		;
m5:		SET	BIT_LED_RT,A
		;
m6:		LD	(RAM_PIO1BDAR),A
		;
		DEC	H
		JR	NZ,m4

		LD	HL,UPPER_MEM1
		LD	DE,RAMSTART
		LD	BC,1*(UPPER_MEM2-UPPER_MEM1)	;Laenge der Uebertragungsdateien
		LDIR
		;
		LD	A,(RAM_PIO1BDAR)
		;
		JP	RAMSTART





; ***** ANFANG Initialisierung der Hardware *****


; Anfangsinitialisierung der Perepheriebausteine
;
INIT:	LD	HL,INITAB	;Adresse der Initialisierungs-
				;tabelle
	LD	B,1*(INITAE-INITAB)/2	;laenge der Initialisierungst.
	;
INIT1:	LD	C,(HL)		;laden der neuen Geraeteadresse
	INC	HL		;naechstes Ausgabebyte
	OUTI			;Ausgabe von (HL) an Adresse C
				;danach: HL+1 , B-1
	JR	NZ,INIT1
	;
	RET	


INITAB:				;Initialisierungstabelle
	; Interruptsperre fuer alle Perepheriebausteine

	DB	PIO1AC		;PIO 1 A
	DB	3
	;
	DB	PIO1BC		;PIO 1 B
	DB	3
	;

	; Initialisierung der Betriebsarten der PIO's

	; --- Initialisierung der PIO Port A

	; vor dem Freischalten der Ausgaenge wird das Ausgaberegister fuer
	; die Daten definiert gesetzt
	; Port A - Daten alles 0
	DB	PIO1AD
	DB	00000000B
	;
	; MODE3 Bitbetrieb (Maske folgt)
	DB	PIO1AC
	DB	0CFH
	;
	; Maske fuer Bitbetrieb Port A (Daten - alles Eingaenge)
	DB	PIO1AC
	DB	BITMSKAE
	;


	; --- Initialisierung der PIO Port B

	; vor dem Freischalten der Ausgaenge wird das Ausgaberegister fuer
	; die Daten definiert gesetzt
	DB	PIO1BD
	DB	PIO1BDAR


	; MODE3 Bitbetrieb (Maske folgt)
	DB	PIO1BC
	DB	0CFH


; Bitmaske Port B - Initialisierung
; B0 = DDWR   = 0 - Ausgang
; B1 = DDAC   = 1 - Eingang
; B2 = SDEN   = 0 - Ausgang
; B3 = SRAC   = 1 - Eingang 
; B4 = RAMSEL = 0 - Ausgang
; B5 = LED_RT = 0 - Ausgang
; B6 = LED_GE = 0 - Ausgang
; B7 = LED_GN = 0 - Ausgang
	DB	PIO1BC
	DB	00001010B

	; Setzen des Ausgaberegister -> definierter Pegel fuer die Steuerleitungen
	DB	PIO1BD
	DB	PIO1BDAR



INITAE:	DW	4		;ROMOF
;


; ***** ENDE Initialisierung der Hardware *****


